;          PIC16F628
;   1 


	list	P=PIC16F628A 

#include <P16F628A.INC>


; 

SEK         	EQU    	21h ;   
MIN         	EQU    	22h ;   
UHR         	EQU    	23h ;    

;    PIC16F628A  -3F08  (LP      32,768 )
;   :

; RA0 -    "0"
; RA1 -    "1"
; RA2 -    "2"
; RA3 -    "3"
; RA4 -    "4"
; RA4 -  ,   GND

; RB0 -      
; RB1 -      
; RB2 -     
; RB3 - 
; RB4 - 
; RB5 -   "5"
; RB6 -  
; RB7 -      

		org 0
		GOTO SBROS
		ORG 4
		GOTO PRER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SBROS:
;		        
;       
	MOVLW b'00000000'; 
	BSF  STATUS,5	;    1
	TRIS PORTA ;	   PORTA    ,  RA5,       ,
					BCF  STATUS,5;    0	
	BSF  CMCON,0   ;   RA0-RA3  
	BSF  CMCON,1
	BSF  CMCON,2
	MOVLW b'11111111'  ;    
	MOVWF    PORTA

	MOVLW b'10000011'  
	BSF  STATUS,5	;    1	
	TRIS PORTB ;     PORTB   ,  RB0,RB1  RB7,    
	BCF  STATUS,5;    0	
	MOVLW b'11111111'  ;   B
	MOVWF    PORTB
		
	BSF  STATUS,5	;           
	BCF OPTION_REG,7
	BCF  STATUS,5
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

;       (         ) 

	MOVLW b'11111110'  ;  0
	MOVWF  PORTA
	CALL  MS100	
	
	MOVLW b'11111101'  ;  1
	MOVWF  PORTA
	CALL  MS100
	
	MOVLW b'11111011'  ;  2 
	MOVWF  PORTA
	CALL  MS100	
	
	MOVLW b'11110111'  ;  3 
	MOVWF  PORTA
	CALL  MS100
	
	MOVLW b'11101111'  ;  4
	MOVWF  PORTA
	CALL  MS100	
	MOVLW b'11111111'  ;  4 
	MOVWF  PORTA
	
	MOVLW b'11011111'  ;  5 
	MOVWF  PORTB
	CALL  MS100
	
	MOVLW b'10111111'  ;  6
	MOVWF  PORTB
	CALL  MS100	
	
	MOVLW b'11111111'  ; 
	MOVWF  PORTB
	CALL  MS100		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;     
		CLRF   SEK
		CLRF   MIN
		CLRF   UHR
;   TMR1
	MOVLW b'11100000'
	MOVWF TMR1H;     1
	CLRF T1CON
	BSF T1CON,0 ; 1
	BCF PIR1,0 ;     1
	BSF STATUS,5;  1

	CLRF INTCON
	BSF INTCON,6 ;      
	BSF INTCON,7 ;   
	BSF PIE1,0 ;    1
	BCF STATUS,5 ;  0

ZIKL:		; ,      
		GOTO ZIKL

PRER:
	BCF T1CON,0 ;  1 
	MOVLW b'11100000'
	MOVWF TMR1H;     1  
	MOVLW b'00001101'
	MOVWF TMR1L;     1  
	BSF T1CON,0 ; 1
	BCF PIR1,0 ;      1
	BSF STATUS,5;        1
	CLRF INTCON;           
	BSF INTCON,6;        
	BSF INTCON,7;       
	BSF PIE1,0 ;    1
	BCF STATUS,5;       0

;    1 
		INCF  SEK,1
		MOVF  SEK,0
				XORLW b'00111100'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  SEK

		INCF  MIN,1
		MOVF  MIN,0
				XORLW b'00111100'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  MIN

UB_UHR:
		INCF UHR,1
		MOVF UHR,0
				XORLW b'00011000'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  UHR

;         ,      
PER_T:
		BTFSC  PORTB,0 ; ,      
		GOTO   PER_MIN ;RETURN
		BTFSC  PORTB,7 ; ,      	
			GOTO M1
;     "1"
		INCF UHR,1
		MOVF UHR,0
				XORLW b'00011000'
				BTFSS  STATUS,Z
		GOTO  $+2
				CLRF  UHR
M1:
	COMF  UHR,0;  
		MOVWF PORTA
		MOVWF PORTB
;      
		BCF PORTB,6
		CALL MS10
		BSF PORTB,6



	RETURN

PER_MIN:
		BTFSC  PORTB,1 ; ,      
		GOTO SBROS_IND
		BTFSC  PORTB,7 ; ,      	
			GOTO $+3
		CLRF  SEK
		CLRF  MIN


	COMF  MIN,0;  SEK,0
		MOVWF PORTA
		MOVWF PORTB
;      
		BCF PORTB,6
		CALL MS10
		BSF PORTB,6
	RETURN

;  ,      
SBROS_IND:
		MOVLW 0FFH
		MOVWF PORTA
		MOVWF PORTB

	RETURN
;///////////////////////////////////////////
;      
;  1 
MS01:
			NOP
			NOP			
			NOP
			NOP
			NOP
			NOP			
			NOP
			NOP
		RETURN

;///////////////////////////////////////////
;  10 
MS10:
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		CALL MS01
		RETURN

;///////////////////////////////////////////
;  100 
MS100:
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		CALL MS10
		RETURN
;///////////////////////////////////////////
			ORG 0X00002007   ;    
			DW  0X3F08

		END
